<template>
  <b-row>
    <b-col cols="12" lg="6">
      <b-card no-header>
        <!-- <el-radio v-model="radio" label="1">Male</el-radio>
        <el-radio v-model="radio" label="2">Female</el-radio>
        <div class="block">
          <span class="demonstration">Birthdate</span>
          <el-date-picker v-model="value1" type="date" placeholder="Pick a day"></el-date-picker>
        </div> -->
        <template slot="header" v-if="$route.params.id != undefined">Edit Category</template>
        <template slot="header" v-if="$route.params.id == undefined">Add Category</template>
        <template>
          <el-row>
            <el-col :span="6">
              <label>Name:</label>
            </el-col>
            <el-col :span="18">
              <el-input placeholder="Please input" v-model="category.name"></el-input>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <label>Code:</label>
            </el-col>
            <el-col :span="18">
              <el-input placeholder="Please input" v-model="category.code"></el-input>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <label>Description</label>
            </el-col>
            <el-col :span="18">
              <el-input
                type="textarea"
                :autosize="{ minRows: 2, maxRows: 4}"
                placeholder="Please input"
                v-model="category.description"
              ></el-input>
            </el-col>
          </el-row>
        </template>
        <template slot="footer">
          <b-button
            variant="primary"
            v-if="$route.params.id == undefined"
            @click="insertCategory"
          >{{ $route.params.id == undefined ? 'Add' : 'Update' }}</b-button>
          <b-button
            variant="primary"
            v-if="$route.params.id != undefined"
            @click="updateCategory"
          >Update</b-button>
          <b-button @click="goBack">Back</b-button>
        </template>
      </b-card>
    </b-col>
  </b-row>
</template>

<script>
import { mapGetters } from "vuex"
import store from "@/store"
import { CATEGORY_LIST_PAGE, CATEGORY_UPDATE } from "@/store/actions.type"
import { SET_CATEGORY, SET_CATEGORIES } from "@/store/mutations.type"
import { CATEGORY_FETCH, CATEGORY_RESET_STATE, CATEGORY_INSERT } from "@/store/actions.type"
export default {
  name: "Category",
  props: {},
  data: () => {
    return {
      caption: "Categories",
      radio: "1",
      value1: undefined
    }
  },
  computed: {
    ...mapGetters(["category"])
    // category() {
    //   return this.$store.getters.category
    // }
  },
  async beforeRouteUpdate(to, from, next) {
    // Reset state if user goes from /editor/:id to /editor
    // The component is not recreated so we use to hook to reset the state.
    await store.dispatch(CATEGORY_RESET_STATE)
    console.log("beforeRouteUpdate")
    return next()
  },
  async beforeRouteEnter(to, from, next) {
    // SO: https://github.com/vuejs/vue-router/issues/1034
    // If we arrive directly to this url, we need to fetch the article
    await store.dispatch(CATEGORY_RESET_STATE)
    if (to.params.id !== undefined) {
      await store.dispatch(CATEGORY_FETCH, to.params.id)
    }
    console.log("beforeRouteEnter")
    return next()
  },
  async beforeRouteLeave(to, from, next) {
    console.log("beforeRouteLeave")
    await store.dispatch(CATEGORY_RESET_STATE)
    next()
  },
  mounted() {
    // this.fetchCategory()
  },
  // watch: {
  //   category: function(val, oldVal) {
  //     console.log("new: %s, old: %s", val, oldVal)
  //   }
  // },
  methods: {
    goBack() {
      // this.$router.go(-1)
      this.$router.replace({ path: "/categories" })
    },
    fetchCategoriesList() {
      this.$store.dispatch(CATEGORY_LIST_PAGE)
    },
    fetchCategory() {
      if ($route.params.id != undefined) {
        this.$store.dispatch(CATEGORY_FETCH, $route.params.id)
      }
    },
    updateCategory() {
      this.$store.dispatch(CATEGORY_UPDATE, this.category)
    },
    insertCategory() {
      this.$store.dispatch(CATEGORY_INSERT, this.category)
    }
  }
}
</script>
